app.ModalFuncView = Backbone.View.extend({
    el: "#right",
    modal: false,
    type : false, 
    changed : false,

    templates : {
        main : _.template('\
            <h1><%=type%> <%= tr("rightform.properties") %></h1>\
            <div class="row"></div>\
            <div class="button-group float-right  small"><a class="button" data-submit ><%=tr("rightform.apply")%></a></div>\
        '),

        address : _.template('\
            <div class="row columns"><select style="width:100%"><option></option></select></div>\
        '),

        addaddress : _.template('\
            <form id="newAddressForm" ><div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.name")%></div> \
                <div class="medium-6 columns"><input name="name" value="" type="text"></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.groupaddress")%></div> \
                <div class="medium-6 columns"><input name="address" pattern="^[0-9]{1,2}/[0-9]{1,2}/[0-9]{1,2}$" value="<%=value%>" type="text"></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.datatype")%></div> \
                <div class="medium-6 columns">\
                 <select name="datatype" data-event style="width:100%">\
                    <option value="01"><%=tr("rightform.addaddress.datatype.01","1 bit (boolean)")%></option>\
                    <option value="01001"><%=tr("rightform.addaddress.datatype.01001","switch")%></option>\
                    <option value="01002"><%=tr("rightform.addaddress.datatype.01002","boolean")%></option>\
                    <option value="01003"><%=tr("rightform.addaddress.datatype.01003","enable")%></option>\
                    <option value="01004"><%=tr("rightform.addaddress.datatype.01004","transition")%></option>\
                    <option value="01005"><%=tr("rightform.addaddress.datatype.01005","alarm")%></option>\
                    <option value="01006"><%=tr("rightform.addaddress.datatype.01006","low/high")%></option>\
                    <option value="01007"><%=tr("rightform.addaddress.datatype.01007","step")%></option>\
                    <option value="01008"><%=tr("rightform.addaddress.datatype.01008","up/down")%></option>\
                    <option value="01009"><%=tr("rightform.addaddress.datatype.01009","open/close")%></option>\
                    <option value="01010"><%=tr("rightform.addaddress.datatype.01010","start/stop")%></option>\
                    <option value="1011"><%=tr("rightform.addaddress.datatype.01011","activity")%></option>\
                    <option value="01012"><%=tr("rightform.addaddress.datatype.01012","inversion")%></option>\
                    <option value="01013"><%=tr("rightform.addaddress.datatype.01013","dim style")%></option>\
                    <option value="01014"><%=tr("rightform.addaddress.datatype.01014","data source")%></option>\
                    <option value="02"><%=tr("rightform.addaddress.datatype.02","2 bit (1 bit controlled)")%></option>\
                    <option value="03"><%=tr("rightform.addaddress.datatype.03","4 bit (3 bit controlled)")%></option>\
                    <option value="03007"><%=tr("rightform.addaddress.datatype.03007","dim/blinds step")%></option>\
                    <option value="04"><%=tr("rightform.addaddress.datatype.04","1 byte ASCII character")%></option>\
                    <option value="05"><%=tr("rightform.addaddress.datatype.05","1 byte unsigned integer")%></option>\
                    <option value="05001"><%=tr("rightform.addaddress.datatype.05001","scale")%></option>\
                    <option value="05003"><%=tr("rightform.addaddress.datatype.05003","angle")%></option>\
                    <option value="06"><%=tr("rightform.addaddress.datatype.06","1 byte signed integer")%></option>\
                    <option value="07"><%=tr("rightform.addaddress.datatype.07","2 byte unsigned integer")%></option>\
                    <option value="08"><%=tr("rightform.addaddress.datatype.08","2 byte signed integer")%></option>\
                    <option value="09"><%=tr("rightform.addaddress.datatype.09","2 byte floating point")%></option>\
                    <option value="09001"><%=tr("rightform.addaddress.datatype.09001","Temperature")%></option>\
                    <option value="232"><%=tr("rightform.addaddress.datatype.232","3 byte unsigned integer")%></option>\
                    <option value="232600"><%=tr("rightform.addaddress.datatype.232600","RGB color")%></option>\
                    <option value="10"><%=tr("rightform.addaddress.datatype.10","3 byte time / day")%></option>\
                    <option value="11"><%=tr("rightform.addaddress.datatype.11","3 byte date")%></option>\
                    <option value="12"><%=tr("rightform.addaddress.datatype.12","4 byte unsigned integer")%></option>\
                    <option value="13"><%=tr("rightform.addaddress.datatype.13","4 byte signed integer")%></option>\
                    <option value="14"><%=tr("rightform.addaddress.datatype.14","4 byte floating point")%></option>\
                    <option value="15"><%=tr("rightform.addaddress.datatype.15","4 byte access control")%></option>\
                    <option value="16"><%=tr("rightform.addaddress.datatype.16","14 byte ASCII string")%></option>\
                    <option value="16002"><%=tr("rightform.addaddress.datatype.16002","14 byte HEX")%></option>\
                    <option value="20"><%=tr("rightform.addaddress.datatype.20","1 byte enumeration")%></option>\
                    <option value="20004"><%=tr("rightform.addaddress.datatype.20004","priority")%></option>\
                    <option value="20007"><%=tr("rightform.addaddress.datatype.20007","alarm class")%></option>\
                    <option value="20102"><%=tr("rightform.addaddress.datatype.20102","HVAC mode")%></option>\
                    <option value="20110"><%=tr("rightform.addaddress.datatype.20110","heater mode")%></option>\
                    <option value="20111"><%=tr("rightform.addaddress.datatype.20111","fan mode")%></option>\
                    <option value="20112"><%=tr("rightform.addaddress.datatype.20112","master/slave mode")%></option>\
                    <option value="27001"><%=tr("rightform.addaddress.datatype.27001","4 byte combined on/off")%></option>\
                    <option value="29"><%=tr("rightform.addaddress.datatype.29","8 byte signed integer")%></option>\
                    <option value="255"><%=tr("rightform.addaddress.datatype.250","byte string")%></option>\
                    <option value="238600"><%=tr("rightform.addaddress.datatype.238600","1 byte DALI diagnostics")%></option>\
                    <option value="245600"><%=tr("rightform.addaddress.datatype.245600","6 byte DALI test result")%></option>\
                    <option value="250600"><%=tr("rightform.addaddress.datatype.250600","3 byte DALI brightness and color temperature control")%></option>\
                    <option value="251600"><%=tr("rightform.addaddress.datatype.251600","6 byte DALI RGBW")%></option>\
                 </select>\
                </div>\
            </div>\
            \<div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.tags")%></div> \
                <div class="medium-6 columns"><input  name="tags" value="" type="text"></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.unitsuffix")%></div> \
                <div class="medium-6 columns"><input  name="units" value="" type="text"></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.log")%></div> \
                 <div class="medium-6 columns"><input name="log" type="checkbox" value="1" ></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.prioritylog")%></div> \
                <div class="medium-6 columns"><input  name="highpriolog" type="checkbox" value="1" ></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.export")%></div> \
                <div class="medium-6 columns"><input  name="export" type="checkbox" value="1" ></div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.readstartup")%></div> \
                <div class="medium-6 columns"><input  name="readoninit" type="checkbox" value="1" </div>\
            </div>\
            <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.poolinterva")%></div> \
                <div class="medium-6 columns"><input  name="pollinterval" value="<%=value%>"" type="number"  min="0"></div>\
            </div>\
             <div class="row">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.addaddress.comment")%></div> \
                <div class="medium-6 columns"><textarea name="comment"></textarea></div>\
            </div>\
            </form>\
        '),

        timer : _.template('\
            <div class="row timer">\
                <div class="medium-6 columns field-label" ><%=tr("rightform.seconds")%></div> \
                <div class="medium-6 columns"><input value="<%=value%>" type="number" min="0" max="60" ></div>\
            </div>\
        '),

        storage : _.template('\
            <div class="row">\
                <div class="medium-4 columns field-label"><%=tr("rightform.storage_key")%></div> \
                <div class="medium-8 columns"><input value="<%=value%>" type="text"></div>\
            </div>\
        '),

        value : _.template('\
            <div class="row">\
                <div class="medium-4 columns field-label"><%=tr("rightform.value")%></div> \
                <div class="medium-8 columns"><input value="<%=value%>" type="text"></div>\
            </div>\
        '),

        func: _.template('\
            <div class="row">\
                <div class="medium-4 columns field-label"><%=tr("rightform.event")%></div>\
                <div class="medium-8 columns" id="select-change-event">\
                    <select data-event style="width:100%">\
                        <option value="timer"><%= tr("rightform.timer")%></option>\
                        <% if (get("input").length>0) { %>\
                            <option value="event"><%=tr("rightform.event")%></option>\
                        <% } %>\
                    </select>\
                </div>\
            </div>\
            <p class="lead input-lead"><%=tr("rightform.input")%> <span class="select-inputs-warning"><%=tr("rightform.select_inputs")%></span></p><form class="in-form">\
              <% i=0; _.each(get("input"), function(p, id) { i++; v=p.value; \
                if (_.isObject(v) && (v.type=="function" || v.link)) { %> \
                    <div class="row first<%=(i%2==0?" even":"")%>" data-id="<%=id%>">\
                        <div class="medium-12 columns field-label"><%=p.n%></div> \
                    </div><div class="row line<%=(i%2==0?" even":"")%>" data-id="<%=id%>">\
                        <div class="medium-12 columns linked">Port is connected to Element</div>\
                    </div>\
                <%}else{%>\
                    <div class="row first<%=(i%2==0?" even":"")%>" data-id="<%=id%>">\
                        <div class="medium-4 columns"><input type="checkbox" id="show_in_<%=id%>" value="<%=id%>" data-show class="save-on-change-checkbox color-on-event"><label for="show_in_<%=id%>"><%=tr("rightform.show")%></label></div>\
                        <div class="medium-8 columns field-label"><%=tr(p.n)%></div> \
                    </div><div class="row line<%=(i%2==0?" even":"")%>" data-id="<%=id%>">\
                        <div class="medium-5 columns"><select id="in_<%=id%>" style="width:100%" data-type></select></div>\
                        <div class="medium-7 columns value"></div>\
                    </div>\
              <% } \
                }) %>\
            </form>\
            <% if (_.size(get("output"))>0) { %> \
                <p class="lead output-lead" ><%=tr("rightform.output")%></p><form class="out-form">\
            <% } %> \
              <% i=0; _.each(get("output"), function(p, id) { i++; %> \
            <div class="row line first<%=(i%2==0?" even":"")%>">\
                  <div class="medium-4 columns"><input type="checkbox" id="show_out_<%=id%>" value="<%=id%>" data-show class="save-on-change-checkbox"><label for="show_out_<%=id%>"><%=tr("rightform.show")%></label></div>\
                  <div class="medium-5 columns"><input type="checkbox" id="bus_out_<%=id%>" value="<%=id%>" data-bus><label for="bus_out_<%=id%>"><%=tr("rightform.write_to_bus")%></label></div>\
                  <div class="medium-3 columns field-label"><%=tr(p.l)%></div>\
                  <div class="medium-8 columns"><select id="out_<%=id%>" style="width:100%" data-type-value multiple="multiple"></select></diV>\
                  <div class="medium-4 columns field-delta"><input type="number" id="mindelta_<%=id%>" value="" data-delta placeholder="<%=tr(\'rightform.min_delta\')%>"></div>\
            </div>\
               <% }) %>\
            </form> \
        ')
    },

    _clearAll : function() {

        if( $("select", this.el) != undefined &&  $("select", this.el) != null ){
            $("select", this.el).select2("destroy");
        }

        this.$el.removeClass('is-active');
        this.type = false;
        this.model = null;
        this.$el.html("");
        this.changed = false;        
    },

    clearAll : function() { 
        if (!this.changed) return this._clearAll();

        if (this.type == "qad.Question") { 
            appView.selection.reset([this.model.get("shape")]);
        }else{ 
            appView.selection.reset([this.model]);
        }

        var t = this;
        new app.ModalQuestion({
            /*text : "All changes will be lost. Deselect the block?", */
            text : tr("rightform.apply_changes_q"),
            buttonCancel : tr("general.No"),
            buttonOK : tr("general.Yes"),
            class : "none",
            ok : function() {
                t.apply(true);
                t._clearAll();
                appView.selection.reset([]);       
            },
            cancel : function() {
                t._clearAll();
                appView.selection.reset([]);       
            }
        });

    },

    getTitle : function() { 
        var title = ""; 
        if (this.type=="qad.Question") title = tr("rightform.Function");
        else if (this.type=="qad.Address") title = tr("rightform.Address");
        else if (this.type=="qad.Tag") title = tr("rightform.Tag");
        else if (this.type=="qad.Timer") title = tr("rightform.Timer");
        else if (this.type=="qad.AddAddress") title = tr("rightform.AddAddress");
        return title;
    },

    initFuncModel : function() { 

        var t = this;
        var d = $(".row", t.el);
        d.html(t.templates.func(t.model));

        $(".save-on-change-checkbox").each(function(i,e){
            $(e).change(function(){
                t.apply(true);
            });
        });

        $("#select-change-event select").change(function(){
            if($(this).val()=="event"){
                $(".color-on-event").parent().addClass("red-highlight");
                $(".select-inputs-warning").addClass("select-inputs-warning-highlighted");
            }else{
                $(".color-on-event").parent().removeClass("red-highlight");
                $(".select-inputs-warning").removeClass("select-inputs-warning-highlighted");
            }
        });


        var sE = $("select[data-event]", t.el)
        sE.select2({minimumResultsForSearch: Infinity}); 

        _.each(this.model.get("input"), function(p, i) {
            var defTypeValue = "value";
            if ("t" in p && _.isArray(p.t) && p.t.length>0) defTypeValue = p.t[0];

            var s = $("#in_" + i, t.el),
                typ = _.isObject(p.value) ? p.value.type : defTypeValue;

            if (_.isObject(p.value) && (p.value.type == "function" || p.value.link)) { 
                //t.initInputTypeValueControlLinked(s, p);                
            }else { 

                t.initInputTypeValueControl(s, p);
                s.data("id", i).val(typ).trigger("change");

                if (p.show) $(".in-form .row[data-id="+i+"] input[data-show]", t.el).prop("checked", true);

                if (_.isObject(p.value)) { 
                    if (p.value.value !== false) { 
                        $("#in_v_" + i, t.el).val(p.value.value).trigger("change");
                    }
                }
            }

        })

        this.objectsEvent();
        var e = this.model.get("event");
        sE.val(e).trigger("change");

        _.each(this.model.get("output"), function(p, i) {
            var s = $("#out_" + i, t.el);
            if (p.show) $("#show_out_" + i, t.el).prop("checked", true);
            if (p.bus || _.isUndefined(p.bus)) $("#bus_out_" + i, t.el).prop("checked", true);

            delta = parseFloat(p.delta);
            if (!_.isNaN(delta)) 
                $("#mindelta_" + i, t.el).val(delta);

            t.initOutputValueControl(s, p);
            if (_.isArray(p.values)) {
                var values = [];
                _.each(p.values, function(v) { values.push(v.value); });
                s.val(values).trigger("change");
            }
        })

    },

    initModel: function(model) {
        this.type = model.get("type");
        if (this.type == "qad.Question") model = model.get("m");
        if (this.model!=null && this.model.cid==model.cid)  return true;

        this.model = model;
        this.$el.html(this.templates.main({type:this.getTitle()}));

        if (this.type == "qad.Question") { 
            this.initFuncModel();
        }else{
            var d = $(".row", this.el);
            if (this.type == "qad.Address" || this.type== "qad.Addressnotevent") {
                d.html(this.templates.address());
                var s = $("select", d);
                    s.select2({ templateResult: function (data, container) {
                        if (data) {
                            $(container).css("background",data.bcolor);
                            $(container).css("color",data.fcolor);
                        }
                        return data.text;
                    },
                    data: select2Data.objects,
                    allowClear: true,
                    placeholder: tr("rightform.select_address")
                })
                var address = this.model.get("value");
                if (address) s.val(address).trigger("change");
            }else if (this.type == "qad.Tag") { 
                d.html(this.templates.address());
                var s = $("select", d);
                s.select2({
                    data: select2Data.tags,
                    allowClear: true,
                    placeholder: tr("rightform.select_tagname")
                })
                var tag = this.model.get("value");
                if (tag) s.val(tag).trigger("change");
            }else if (this.type == "qad.Timer") { 
                var v = this.model.get("value");
                d.html(this.templates.timer({value:v}));
            }else if (this.type == "qad.Storage") { 
                var v = this.model.get("value");
                if (v===false) v = "";
                d.html(this.templates.storage({value:v}));
            }else if (this.type == "qad.Value") { 
                var v = this.model.get("value");
                if (v===false) v = "";
                d.html(this.templates.value({value:v}));
            }else if (this.type == "qad.AddAddress") {
                d.html(this.templates.addaddress({value:""}));
            }
        }

        if (!this.$el.hasClass('is-active')) this.$el.addClass('is-active');

        this.changed = false;

        return;
    },

    submitFunc : function(e) { 
        this.model.set("event", $("select[data-event]", this.el).val());
        
        var t = this;
        var inputs = this.model.get("input"); //this.model.attributes.input;
        _.each(inputs, function(p, i) {
            var typeIn = $("#in_" + i, this.el);
            if (typeIn.length>0) {
                var res = false,
                    type = typeIn.val(),
                    value = $("#in_v_" + i, this.el).val();
                if (type == "value" || type == "storage") {
                    var v = false;
                    if (value && value.length > 0) v = value;
                    res = { type: type, value: v };
                } else if (type == "object" || type == "tag") {
                    var v = false;
                    if (value) v = value;
                    res = { type: type, value: v };
                } else if (type == "unique_string") {
                     res = { type: type };
                }
                p.value = res;
            }

            var chShow = $(".in-form .row[data-id="+i+"] input[data-show]", t.el);
            if (chShow.length>0) { 
                p.show = chShow.prop("checked");
            }

        })
        this.model.set("input", inputs);

                   var outputs = this.model.get("output");
        _.each(outputs, function(p, i) {
            var value = $("#out_" + i, this.el).val(),
                res = [];
            p.show = $("#show_out_" + i, this.el).prop("checked");
            p.bus = $("#bus_out_" + i, this.el).prop("checked");

            var delta = parseFloat($("#mindelta_" + i, this.el).val());
            if (!_.isNaN(delta)) p.delta = delta;

            if (value && _.isArray(value)) {
                _.each(value, function(v) {
                    var type = false;
                    if (v in objects) 
                        type = "object"
                    else if (_.find(tags, function(t) {return t == v })) 
                        type = "tag";

                    if (type) res.push({ type: type, value: v});
                })
            }

            p.values = res;
        })
        this.model.set("output", outputs);

        this.model.updateShape();
        checkLinks(this.model.get("shape"));

            //console.log(12);
        appView.status('Function "' + this.model.get("title") + '"" saved');
    },

    events: {
//==============================================это все про адрес=================================================================================
        "click checkbox" : function() { 
            this.changed = true;
        },
        "change select" : function(){
            this.changed = true;
        },
        "change input" : function(){ 
            this.changed = true;
        },
        "click input" : function(){
            this.changed = true;
        },

        //входящие параметры/выбор event параметра 
        "change select[data-event]" : function(e) { 
            this.changed = true;
            var v = $(e.currentTarget).val();
            //$(".in-form .row.event input", this.el).prop("disabled", false);
            //$(".in-form .row.event select", this.el).prop("disabled", false).trigger("change");
            $(".in-form .row.event[data-id]", this.el).removeClass('event');
            if (v!="timer") { 
                v = parseInt(v);
                if (!_.isNaN(v)) { 
                    $(".in-form .row[data-id="+v+"]", this.el).addClass('event');
                   // $(".in-form .row.event input", this.el).prop("disabled", true);
                    //$(".in-form .row.event input[type=checkbox]", this.el).prop("checked", false);
                   // $(".in-form .row.event select", this.el).prop("disabled", true).trigger("change");
                }
            }
        },
        //входящие параметры/изменили тип данных 
        "change .in-form select[data-type]": function(e) {
            this.changed = true; 

            var t = $(e.currentTarget),
                v = t.val();
            this.initInputValueControl(t);

            if (v == "value" || v == "storage" || v=="unique_string")
                $("input[data-event]", t.closest("div.row")).prop("disabled", true);
            else
                $("input[data-event]", t.closest("div.row")).prop("disabled", false);
        },
        //исходящие парметры
        "select2:select .out-form [data-type-value]": function(e) {
            this.changed = true;

            var s = $(e.currentTarget);
            if (s.val().length == 1) {
                var c = $("input[data-show]", s.closest('div.row'));
                if (!c.prop("checked")) c.prop("checked", true);
            }
        },
        "select2:unselect .out-form [data-type-value]": function(e) {
            this.changed = true; 

            var s = $(e.currentTarget);
            if (!s.val()) {
                var c = $("input[data-show]", s.closest('div.row'));
                if (c.prop("checked")) c.prop("checked", false);
            }
        },

//==========================================общая по apply ===========================================================================================        
        "click a[data-submit]": function(e) {
            this.apply(e);
        }
    },

    apply : function(e) {

        if (this.type == "qad.Question") {
            this.submitFunc(e);
        }
        else if (this.type == "qad.AddAddress") {
            this.addObject(this,appView.selection);

        }
        else if (this.type == "qad.Address" || this.type == "qad.Tag" || this.type == "qad.Addressnotevent") { 
            var v = $("select", this.el).val();
            if (!v) v = false;
            this.model.set("value", v);

            //if (this.type == "qad.Addressnotevent") { 
                updateLinkedQuestion(this.model);
            //}

        }else if (this.type == "qad.Timer") { 
            var v = parseInt($("input", this.el).val());
            if (_.isNaN(v)){
                v = 0
            }else {
                v = v < 0 ? 0 : (v > 60 ? 60 : v);
            }
            $("input", this.el).val(v);
            this.model.set("value", v);
        }else if (this.type == "qad.Storage") {             
            var v = $("input", this.el).val().trim();
            if (v.length==0) v = false;
            this.model.set("value", v);
            updateLinkedQuestion(this.model);
        }else if (this.type == "qad.Value") {             
            var v = $("input", this.el).val();
            if (v.length==0) v = false;
            this.model.set("value", v);
            updateLinkedQuestion(this.model);
        }
        this.changed = false;
    },


    addObject : function(e,s){
        //validate
        $.get("api/?a=save_object", $("#newAddressForm").serialize(), function(result){
            result = parseJSON(result)

            if(result.result ==null || result.result == undefined || result.result==0){
                if(result.message != undefined){
                    alert(tr(result.message));
                }else{
                    alert(tr("rightform.unableToSaveObject"))
                }
            }else{
                objects = parseJSON( result.objects);
                tags =parseJSON(result.tags);

                _.each(objects, function(o, id){
                    var tags = o.tags;
                    if (_.isUndefined(tags)) tags = "";
                    tags = tags.split(",");
                    objects[id].tags = _.chain(tags)
                        .map(function(t){ return t.trim(); })
                        .filter(function(t){ return t.length>0; })
                        .value();
                });

                select2Data.objects = _.map(objects, function(o){
                    o.text = o.address + (o.name ? " (" + o.name + ")" : "")
                    return o;
                });

                select2Data.tags = _.map(tags, function(o) {
                    return {
                        id : o,
                        text : o
                    }
                })

                select2Data.objects = _.sortBy(select2Data.objects, function(o){return o.key})
                select2Data.tags = _.sortBy(select2Data.tags, function(o){return o.id})
                alert(tr("rightform.objectAddedSuccessfully"))
            }


        })

    },
    //инициализация select2/входящие параметры/тип данных
    initInputTypeValueControl: function(s, p) {

        //var tr = s.closest("div.row");

        var data = []; 

        if (isEnabledDataTypeForPort("value", p)) 
            data.push({ id: "value", text: tr("rightform.inputtype.value")});

        if (isEnabledDataTypeForPort("object", p)) 
            data.push({ id: "object", text:  tr("rightform.inputtype.object")});

        if (isEnabledDataTypeForPort("tag", p)) 
            data.push({ id: "tag", text: tr("rightform.inputtype.tag")});

        if (isEnabledDataTypeForPort("storage", p)) 
            data.push({ id: "storage", text:  tr("rightform.inputtype.storage")});

        if (isEnabledDataTypeForPort("unique_string", p)) 
            data.push({ id: "unique_string", text: tr("rightform.inputtype.unique_string")});

        s.select2({
            data: data,
            placeholder:  tr("rightform.inputtype.selecttype"),
            minimumResultsForSearch: Infinity
        });
    },

    //шаблоны поля для выбора откуда берем значение / входящие параметры  
    ctemplates: {
        storage: _.template('<input class="inline" type="text" id="in_v_<%=id%>" data-type-value="storage">'),
        value: _.template('<input class="inline" type="text" id="in_v_<%=id%>" data-type-value="value">'),
        value_select: _.template('<select id="in_v_<%=id%>" data-type-value="value" style="width:100%"><option></option></select>'),
        object: _.template('<select id="in_v_<%=id%>" data-type-value="object" style="width:100%"><option></option></select>'),
        tag: _.template('<select id="in_v_<%=id%>" data-type-value="tag"  style="width:100%"><option></option></select>'),
    },

    //инициализация контрола/входящие параметры/во что писать 
    initInputValueControl: function(s) {
        var value = s.val(),
            td = s.closest("div.row"),
            i = $("[data-type-value]", td),
            prevValue = false;

        if (i.length > 0) prevValue = i.eq(0).data("typeValue");
        if (prevValue && value !== prevValue) {
            if (i.get(0).tagName == "SELECT") i.select2("destroy");
            i.remove();
        }
        if (prevValue !== value && value in this.ctemplates) {
            var o = { id: s.data("id") };
            var dv = $("div.columns.value", td);
            dv.html("");
            
            var key = value, vs;
            if (key=="value") {
                if(this.model != undefined && this.model!=null){
                    var inputs = this.model.get("input");
                    if(inputs != undefined) {
                        if (inputs[o.id].vs && _.isArray(inputs[o.id].vs)) {
                            key = "value_select";
                            vs = inputs[o.id].vs;
                        }
                    }
                }
            }

            var e = $(this.ctemplates[key](o)).appendTo(dv);
            if (e.get(0).tagName == "SELECT") this.initInputSelect2Values(e, value, vs);
        }
    },

    //инициализация select2/входящие параметры/объект или тег
    initInputSelect2Values: function(s, type, d) {
        var data = [],
            name = type;

        if (type=="value" && _.isArray(d)) { 
            data = _.map(d, function(s) { return {id:s, text:s} })
        }    
        else if (type == "object") data = select2Data.objects;
        else if (type == "tag") { data = select2Data.tags, name = "tagname"; }

        s.select2({
            templateResult: function (data, container) {
                if (data.element) {
                    $(container).css("background",data.bcolor);
                    $(container).css("color",data.fcolor);
                }
                return data.text;
            },
            data: data,
            allowClear: true,
            placeholder: tr("rightform.select")+ " " + name
        });
    },

    disabledOutputs : {tags:{}, objects:{}},

    objectsEvent : function() {
        this.disabledOutputs = {tags:{}, objects:{}};

        var cell = this.model.get("shape");

        var p; 
        var l = _.find(appView.graph.getLinks(), function(l){
            p = getTargetSource(l);
            return (p.trg && p.trg.cell && p.trg.cell==cell);
        })

        if (l && p.src && p.src.cell) { 
            p = p.src.cell;
            var t = p.get("type");
            var v = p.get("value");
            if (_.isString(v) && v.length>0) { 
                if (t=="qad.Address") {
                    this.disabledOutputs.objects[v] = true;
                    var th  = this;
                    _.each(objects[v].tags, function(o){
                        th.disabledOutputs.tags[o] = true;    
                    })
                }else if (t=="qad.Tag") {
                    this.disabledOutputs.tags[v] = true;
                    var th  = this;
                    _.each(select2Data.objects, function(o){
                        if (_.indexOf(o.tags, v)>=0) { 
                            th.disabledOutputs.objects[o.id] = true;
                        }
                    })
                }
            }
        }

    },

    //инициализация select2/output параметры 
    initOutputValueControl: function(s, p) {
        var data = [], t = this;

        if (isEnabledDataTypeForPort("object", p)) {
            var ch = _.map(select2Data.objects, function(o){
                o = _.clone(o);
                o.disabled  = t.disabledOutputs.objects[o.id] || false;
                return o;
            })

            data.push({
                text: tr("rightform.objects"),
                children: ch
            })
        }

        if (isEnabledDataTypeForPort("tag", p)) {
            var ch = _.map(select2Data.tags, function(o){
                o = _.clone(o);
                o.disabled  = t.disabledOutputs.tags[o.id] || false;
                return o;
            })

            data.push({
                text: "TagName",
                children: ch
            })
        }

        s.select2({
            templateResult: function (data, container) {
                if (data) {
                    $(container).css("background",data.bcolor);
                    $(container).css("color",data.fcolor);
                }
                return data.text;
            },
            data: data,
            placeholder: tr("rightform.select_output"),
            templateSelection: function(data) {
                return data.address || data.text;
            }
        });
    }
})
