var app = app || {};

app.Factory = {
  createFunction: function(f) {
    var q = new joint.shapes.qad.Question({
        size: { width: 100, height: 70 },
        question: f.get("name"),
        outOptions: f.getOutputsForShape(),
        inOptions:  f.getInputsForShape(),
        m : f,
    });
    f.set("shape", q);
    return q;
  },

  createAnswer: function(text) {
      var a = new joint.shapes.qad.Answer({
          answer: text
      });
      return a;
  },

  createAddress : function(text) { 
      return new joint.shapes.qad.Address({});
  },

  createTimer : function(text) { 
      return new joint.shapes.qad.Timer({});
  },

  createTag : function(text) { 
      return new joint.shapes.qad.Tag({});
  },

  createUID : function(text) { 
      return new joint.shapes.qad.UID({});
  },

  createStorage : function(text) { 
      return new joint.shapes.qad.Storage({});
  },
  createValue : function(text) { 
      return new joint.shapes.qad.Value({});
  },
  createAddressNotEvent : function(text) { 
      return new joint.shapes.qad.Addressnotevent({});
  },



/*
    createLink: function(source, target) {

        return new joint.dia.Link({
            source: { id: source },
            target: { id: target },
            attrs: { 
                '.marker-target': { d: 'M 10 0 L 0 5 L 10 10 z', fill: '#6a6c8a', stroke: '#6a6c8a' },
                '.connection': { stroke: '#6a6c8a', 'stroke-width': 2 }
            }
        });
    },
*/
};
